/*
 * Copyright 2006 Takahiro Nakamura.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package woolpack.misc;

import woolpack.fn.Fn;

/**
 * スリープするテスト用の{@link Fn}です。
 * 
 * @author nakamura
 * 
 * @param <C>
 * @param <R>
 */
public class SleepFn<C, R> implements Fn<C, R> {
	private long sleepMillis;

	public SleepFn(final long sleepMillis) {
		this.sleepMillis = sleepMillis;
	}

	public R exec(final C c) {
		if (sleepMillis > 0) {
			try {
				Thread.sleep(sleepMillis);
			} catch (final InterruptedException e) {
				Thread.currentThread().interrupt();
				throw new IllegalStateException(e);
			}
		}
		return null;
	}

	public long getSleepMillis() {
		return sleepMillis;
	}
	public void setSleepMillis(final long sleepMillis) {
		this.sleepMillis = sleepMillis;
	}
}
